<?php
require 'config.php';

function aws_sites()
{
    $sites = array();
    foreach (glob($GLOBALS['confdir'] . '/awstats.*.conf') as $file) {
        $sites[] = preg_replace('/^.*awstats.(.+).conf$/', '\\1', $file);
    }
    return $sites;
}

function aws_historic($site)
{
    $dates = array();
    foreach (glob($GLOBALS['awdata'] . '/awstats*.' . $site . '.txt') as $file) {
        $date = explode(
	    '-',
	    preg_replace(
                '/^.*\/awstats([0-9]{2})([0-9]{4})\\.' . $site . '.txt$/',
		'\\2-\\1',
		$file
            )
        );
	count($date) == 2 && $dates[] = $date;
    }
    return $dates;
}

function aws_createHtml($site, $last = false, $year = null, $month = null)
{
    if (!is_dir($GLOBALS['htmldir'])) {
        die("HTML directory " . $GLOBALS['htmldir'] . " does not exist\n");
    }

    if ($year !== null && $month !== null) {
        //already set
    } else if ($last) {
        $month = date('m', strtotime('last month'));
        $year  = date('Y', strtotime('last month'));
    } else {
        $month = date('m');
        $year  = date('Y');
    }

    $dir = $GLOBALS['htmldir'] . '/' . $site . '/' . $year . '-' . $month . '/';
    if (!is_dir($dir)) {
        mkdir($dir, 0777, true);
    }
    $cmd = $GLOBALS['awsbstp']
        . ' -config=' . escapeshellarg($site)
	. ' -awstatsprog=' . escapeshellarg($GLOBALS['awstats'])
	. ' -update'
	. ' -month=' . $month
	. ' -year=' . $year
	. ' -dir=' . escapeshellarg($dir);
    passthru($cmd);

    if (!$last) {
        aws_updateLink($site, $dir);
    }
}

function aws_updateLink($site, $targetdir)
{
    $curdir = $GLOBALS['htmldir'] . '/' . $site . '/current';
    unlink($curdir);
    symlink($targetdir, $curdir);
}

function aws_createIndex($site)
{
    $dirs = glob($GLOBALS['htmldir'] . '/' . $site . '/*', GLOB_ONLYDIR);
    sort($dirs);
    $links = '';
    foreach ($dirs as $dir) {
        $name = basename($dir);
	$links .= '<li><a href="' . $name . '/awstats.' . $site . '.html">'
	    . $name . '</a></li>';
    }
    $html = <<<XML
<?xml version="1.0" encoding="utf-8"?>
<html>
 <head>
  <title>{$site}</title>
 </head>
 <body>
  <ul>
{$links}
  </ul>
 </body>
</html>
XML;
    file_put_contents(
        $GLOBALS['htmldir'] . '/' . $site . '/index.htm',
	$html
    );
}

function aws_createGlobalIndex()
{
    $dirs = glob($GLOBALS['htmldir'] . '/*', GLOB_ONLYDIR);
    sort($dirs);
    $links = '';
    foreach ($dirs as $dir) {
        $name = basename($dir);
	$links .= '<li><a href="' . $name . '/">'
	    . $name . '</a></li>';
    }
    $html = <<<XML
<?xml version="1.0" encoding="utf-8"?>
<html>
 <head>
  <title>awstats</title>
 </head>
 <body>
  <ul>
{$links}
  </ul>
 </body>
</html>
XML;
    file_put_contents(
        $GLOBALS['htmldir'] . '/index.htm',
	$html
    );
}
?>